import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsLang, CmsLangParam } from './model';

/**
 * 分页查询国际化
 */
export async function pageCmsLang(params: CmsLangParam) {
  const res = await request.get<ApiResult<PageResult<CmsLang>>>(
    '/cms/cms-lang/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询国际化列表
 */
export async function listCmsLang(params?: CmsLangParam) {
  const res = await request.get<ApiResult<CmsLang[]>>(
    '/cms/cms-lang',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加国际化
 */
export async function addCmsLang(data: CmsLang) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-lang',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改国际化
 */
export async function updateCmsLang(data: CmsLang) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-lang',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除国际化
 */
export async function removeCmsLang(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-lang/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除国际化
 */
export async function removeBatchCmsLang(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-lang/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询国际化
 */
export async function getCmsLang(id: number) {
  const res = await request.get<ApiResult<CmsLang>>(
    '/cms/cms-lang/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
